﻿using SilverlightApplication1.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        private MainViewModel model;

        static MainPage()
        {
            var cancelEdit = new CommandBinding(DiagramCommands.CancelEdit, OnCancelEditExecuted, OnCancelEditCanExecute);

            CommandManager.RegisterClassCommandBinding(typeof(RadDiagram), cancelEdit);            
        }

        private static void OnCancelEditExecuted(object sender, ExecutedRoutedEventArgs e)
        {
            var diagram = sender as RadDiagram;
            if (diagram != null)
            {
                var selectedItem = diagram.SelectedItems.FirstOrDefault() as Node;
                if (selectedItem != null)
                {
                    selectedItem.IsEditCancel = true;
                }
            }
        }

        private static void OnCancelEditCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            var diagram = sender as RadDiagram;
            if (diagram != null)
            {
                if (!diagram.SelectedItems.Any())
                    e.CanExecute = false;
                else
                {
                    var selectedItem = diagram.SelectedItems.FirstOrDefault() as Node;
                    if (selectedItem != null)
                    {
                        e.CanExecute = true;
                    }
                }
            }
        }

        public MainPage()
        {            
            InitializeComponent();
            this.DataContext = this.model = new MainViewModel();
        }
    }
}
